/*
 * JBoss, Home of Professional Open Source
 * Copyright 2011, Red Hat, Inc. and/or its affiliates,
 * and individual contributors as indicated by the @author tags.
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA.
 *
 * (C) 2011,
 * @author JBoss, by Red Hat.
 */
import javax.transaction.TransactionManager;

/**
 * This example shows how you can access the transaction manager.
 */
public class TransactionManagerExample {

	/**
	 * Get a reference to the transaction manager and call begin and rollback on
	 * it.
	 * 
	 * @param args
	 *            The command line arguments.
	 * @throws Exception
	 *             In case of error.
	 */
	public static void main(String[] args) throws Exception {
		TransactionManager tm = com.arjuna.ats.jta.TransactionManager
				.transactionManager();

		tm.begin();
		System.err.println(tm.getTransaction());

		tm.rollback();
		System.err.println(tm.getTransaction());
	}

}
